void SetEquipSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, dmg1, dmg2, size, critical, criticalm, attack, type, etype, prob, armor, maxdex, malus, spell, metal, valcount;
	static int minlevelpos, rarepos, pricepos, scriptpos, forbideffectpos, amountpos;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		dmg1 = GetValNumber(Vals, "Damage1", Number);
		dmg2 = GetValNumber(Vals, "Damage2", Number);
		size = GetValNumber(Vals, "Size", Number);
		critical = GetValNumber(Vals, "Critical", Number);
		criticalm = GetValNumber(Vals, "CriticalM", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		type = GetValNumber(Vals, "Type", Number);
		etype = GetValNumber(Vals, "EquipType", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		armor = GetValNumber(Vals, "Armor", Number);
		maxdex = GetValNumber(Vals, "MaxDex", Number);
		malus = GetValNumber(Vals, "Malus", Number);
		spell = GetValNumber(Vals, "SpellF", Number);
		metal = GetValNumber(Vals, "Metal", Number);
		minlevelpos = GetValNumber(Vals, "MinLevel", Number);
		rarepos = GetValNumber(Vals, "Rare", Number);
		pricepos = GetValNumber(Vals, "Price", Number);
		scriptpos = GetValNumber(Vals, "Script", Number);
		forbideffectpos = GetValNumber(Vals, "ForbidEffects", Number);
		amountpos = GetValNumber(Vals, "Amount", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Equipment Source Database (%s)\n", Vals[0]);
		quitprog();
	}

	ZeroMemory(TargetStruct, sizeof(clsEquipSource));

	((clsEquipSource*) TargetStruct)->Name = Vals[name];
	((clsEquipSource*) TargetStruct)->Damage1 = atoi(Vals[dmg1]);
	sscanf(Vals[dmg2], "W%d", &(((clsEquipSource*) TargetStruct)->Damage2));

	((clsEquipSource*) TargetStruct)->Damage3 = 0;
	((clsEquipSource*) TargetStruct)->Size = atoi(Vals[size]);
	((clsEquipSource*) TargetStruct)->Critical = atoi(Vals[critical]);
	((clsEquipSource*) TargetStruct)->CriticalMultiplier = atoi(Vals[criticalm]);
	((clsEquipSource*) TargetStruct)->AttackType = atoi(Vals[attack]);
	((clsEquipSource*) TargetStruct)->Type = atoi(Vals[type]);
	((clsEquipSource*) TargetStruct)->EquipType = atoi(Vals[etype]);
	((clsEquipSource*) TargetStruct)->StdProb = atoi(Vals[prob]);
	((clsEquipSource*) TargetStruct)->Armor = atoi(Vals[armor]);
	((clsEquipSource*) TargetStruct)->MaxDex = atoi(Vals[maxdex]);
	((clsEquipSource*) TargetStruct)->Malus = atoi(Vals[malus]);
	((clsEquipSource*) TargetStruct)->SpellFailure = atoi(Vals[spell]);
	((clsEquipSource*) TargetStruct)->Metallic = atoi(Vals[metal]);
	((clsEquipSource*) TargetStruct)->MinLevel = atoi(Vals[minlevelpos]);
	((clsEquipSource*) TargetStruct)->Rare = atoi(Vals[rarepos]);
	((clsEquipSource*) TargetStruct)->Price = atoi(Vals[pricepos]);
	((clsEquipSource*) TargetStruct)->ForbidEffects = atoi(Vals[forbideffectpos]);
	((clsEquipSource*) TargetStruct)->Amount = atoi(Vals[amountpos]);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsEquipSource*) TargetStruct)->Script)))
	{
		printf("Error in Character Script %s\n", Vals[name]);
		quitprog();
	}
}

void SetWProbSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i, j;
	static int ClassPosition[128];
	static int RacePosition[128];
	static int specialpos;
	static int name, valcount;

	TargetStruct = 0;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			if (Source.CharSource[i].Derrive == ";")
			{
				ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number);
			}
			else
			{
				ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Derrive.buffer, Number);
			}
		}
		for (i = 0;i < Source.RaceSourceCount;i++)
		{
			RacePosition[i] = GetValNumber(Vals, Source.RaceSource[i].Name.buffer, Number);
		}
		name = GetValNumber(Vals, "Name", Number);
		specialpos = GetValNumber(Vals, "SpecialType", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Equipment Source Database\n");
		quitprog();
	}

	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		if (Source.EquipSource[i].Name == Vals[name])
		{
			Source.EquipSource[i].SpecialType = atoi(Vals[specialpos]);

			Source.EquipSource[i].Probability = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetWProbSource-Prob");
			Source.EquipSource[i].RaceProbability = (int*) mallocl(Source.RaceSourceCount * sizeof(int), "SetWProbSource-RaceProb");

			for (j = 0;j < Source.CharSourceCount;j++)
			{
				Source.EquipSource[i].Probability[j] = atoi(Vals[ClassPosition[j]]);
			}
			for (j = 0;j < Source.RaceSourceCount;j++)
			{
				Source.EquipSource[i].RaceProbability[j] = atoi(Vals[RacePosition[j]]);
			}
			return;
		}
	}
	printf("Could not find Equipment %s\n", Vals[0]);
	quitprog();
}

void EquipSourceExit()
{
	int i;
	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		freel(Source.EquipSource[i].Script);
		if (Source.EquipSource[i].Probability)
		{
			freel(Source.EquipSource[i].Probability);
		}
		if (Source.EquipSource[i].RaceProbability)
		{
			freel(Source.EquipSource[i].RaceProbability);
		}
	}
	delete[] Source.EquipSource;
}
