int SourceInit()
{
	int tmp;

	if (SourceInitDone)
	{
		return(0);
	}

	ZeroMemory(&Source, sizeof(clsSource));
	Source.lpSymbolStart = bnf::SymbolNames;

	if (SourceInit<clsDomainSource>(DomainFile, &Source.DomainSource, &Source.DomainSourceCount, &SetDomainSource)) {return(1);}
	if (SourceInit<clsMonsterTypeSource>(MonsterTypeFile, &Source.MonsterTypeSource, &Source.MonsterTypeSourceCount, &SetMonsterTypeSource)) {return(1);}
	if (SourceInit<clsRegionSource>(RegionFile, &Source.RegionSource, &Source.RegionSourceCount, &SetRegionSource)) {return(1);}
	if (SourceInit<clsSchoolSource>(SchoolFile, &Source.SchoolSource, &Source.SchoolSourceCount, &SetSchoolSource)) {return(1);}
	if (SourceInit<clsSizeSource>(SizeFile, &Source.SizeSource, &Source.SizeSourceCount, &SetSizeSource)) {return(1);}
	if (SourceInit<clsTemplateSource>(TemplateFile, &Source.TemplateSource, &Source.TemplateSourceCount, &SetTemplateSource)) {return(1);}
	if (SourceInit<clsSpecialSource>(SpecialFile, &Source.SpecialSource, &Source.SpecialSourceCount, &SetSpecialSource)) {return(1);}

	Source.AttributeNames[0] = "Strke";
	Source.AttributeNames[1] = "Geschicklichkeit";
	Source.AttributeNames[2] = "Konstitution";
	Source.AttributeNames[3] = "Intelligenz";
	Source.AttributeNames[4] = "Weisheit";
	Source.AttributeNames[5] = "Charisma";

	if (SourceInit<clsCharSource>(CharFile, &Source.CharSource, &Source.CharSourceCount, &SetCharSource)) {return(1);}
	if (SourceInit<clsRace>(RaceFile, &Source.RaceSource, &Source.RaceSourceCount, &SetRaceSource, 1)) {return(1);}
	if (SourceInit<clsFeatSource>(FeatFile, &Source.FeatSource, &Source.FeatSourceCount, &SetFeatSource)) {return(1);}
	if (SourceInit<clsSkills>(SkillFile, &Source.SkillSource, &Source.SkillSourceCount, &SetSkillSource)) {return(1);}
	if (SourceInit<clsSpell>(SpellFile, &Source.SpellSource, &Source.SpellSourceCount, &SetSpellSource)) {return(1);}
	if (SourceInit<clsPower>(PowerFile, &Source.PowerSource, &Source.PowerSourceCount, &SetPowerSource)) {return(1);}
	if (SourceInit<clsEffect>(EffectFile, &Source.EffectSource, &Source.EffectSourceCount, &SetEffectSource)) {return(1);}
	if (SourceInit<clsMonster>(MonsterFile, &Source.MonsterSource, &Source.MonsterSourceCount, &SetMonsterSource)) {return(1);}
	DetermineCR(0, 0, 0, NULL, 0, 1);

	if (SourceInit<clsEquipSource>(EquipFile, &Source.EquipSource, &Source.EquipSourceCount, &SetEquipSource)) {return(1);}
	for (tmp = 0;tmp < Source.EquipSourceCount;tmp++)
	{
		Source.EquipSource[tmp].Probability = Source.EquipSource[tmp].RaceProbability = 0;
	}
	if (SourceInit<clsMonster>(WProbFile, NULL, &tmp, &SetWProbSource, 0, true)) {return(1);}

	if (ProfileSourceInit() == 1) {return(1);}

	Source.RaceSource[Source.RaceSourceCount].Name = "Monster";
	Source.RaceSource[Source.RaceSourceCount].PreferedAttackType = 1;
	Source.RaceSource[Source.RaceSourceCount].Probability = 0;
	Source.RaceSource[Source.RaceSourceCount].Size = 0;

	FillArrayFromFile(StartMoneyFile, Source.StartMoney, 100);
	FillArrayFromFile(TreasureFile, Source.Treasure, 100);

	InitMonsterDesc();
	SourceInitDone = true;

	return(0);
}

void SourceExit()
{
	int i;

	if (SourceInitDone)
	{
		printf("Freeing Source Data:");
		printf("Chars, ");CharSourceExit();
		printf("Races, ");RaceSourceExit();
		printf("Feats, ");FeatSourceExit();
		printf("Equipment, ");EquipSourceExit();
		printf("Skills, ");SkillSourceExit();
		printf("Spells, ");SpellSourceExit();
		printf("Powers, ");PowerSourceExit();
		printf("Effects, ");EffectSourceExit();
		printf("Monsters, ");MonsterSourceExit();

		printf("Domains, ");DomainSourceExit();
		printf("MonsterTypes, ");MonsterTypeSourceExit();
		printf("Regions, ");RegionSourceExit();
		printf("Schools, ");SchoolSourceExit();
		printf("Size, ");SizeSourceExit();
		printf("Specials, ");SpecialSourceExit();
		printf("Templates, ");TemplateSourceExit();
		
		printf("Profiles\n");ProfileSourceExit();
	}

	for (i = 0;i < 6;i++)
	{
		Source.AttributeNames[i].~string();
	}

	delete Source.MonsterDesc;

	SourceInitDone = false;
}
