void SetSpecialSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int valcount, namepos, typepos, spelllevelpos, scriptpos;

	if (header)
	{
		namepos = GetValNumber(Vals, "Name", Number);
		typepos = GetValNumber(Vals, "Type", Number);
		spelllevelpos = GetValNumber(Vals, "SpellLevel", Number);
		scriptpos = GetValNumber(Vals, "Script", Number);

		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in SpezialSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsSpecialSource*) TargetStruct)->Name = Vals[namepos];
	((clsSpecialSource*) TargetStruct)->Type = atoi(Vals[typepos]);
	((clsSpecialSource*) TargetStruct)->SpellLevel = atoi(Vals[spelllevelpos]);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsSpecialSource*) TargetStruct)->Script)))
	{
		printf("Error in Special Script %s\n", Vals[namepos]);
		quitprog();
	}
}

void SpecialSourceExit()
{
	int i;
	for (i = 0;i < Source.SpecialSourceCount;i++)
	{
		freel(Source.SpecialSource[i].Script);
	}
	delete[] Source.SpecialSource;
}
